﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;

using ITIN.CSharp;

namespace ITIN.CSharp.BaseObjects.SnapshotDOMExtension
{
    public static class SnapshotDOM
    {
        public static void CopyArrayToSnapshot(Array array, ObservableCollection<Level> snapshot)
        {
            if ((array == null) || (snapshot == null)) return;
            for (int index = 0; index < array.Length; index++)
            {
                Array levelArray = (Array)array.GetValue(index);
                double price = (double)levelArray.GetValue(0);
                double amount = (double)levelArray.GetValue(1);
                if (index >= snapshot.Count)
                {
                    for (int i = 0; i < index + 1 - snapshot.Count; i++)
                    {
                        snapshot.Add(new Level(price, amount));
                    }
                }
                else
                {
                    snapshot[index].Amount = amount;
                    snapshot[index].Price = price;
                }
            }            
        }

        public static void CopyArrayToSnapshot(Array array, BaseObjects.SnapshotDOM snapshot)
        {
            if ((array == null) || (snapshot == null)) return;
            for (int index = 0; index < array.Length; index++)
            {
                Array levelArray = (Array)array.GetValue(index);
                double price = (double)levelArray.GetValue(0);
                double amount = (double)levelArray.GetValue(1);
                if (index >= snapshot.Count)
                {
                    for (int i = 0; i < index + 1 - snapshot.Count; i++)
                    {
                        snapshot.AddUpdate(index + i, price, amount);
                    }
                }
                else
                {
                    snapshot[index].Amount = amount;
                    snapshot[index].Price = price;
                }
            }
        }


    }
}
