﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ITIN.CSharp.SmartCOM
{
    /// <summary>
    /// Вспомогательный класс для логгирования сообщений
    /// </summary>
    public class MessageLogger
    {
        /// <summary>
        /// внешний обработчик добавления в лог сообщения
        /// </summary>
        private Action<string> _OnSendLogMessageReised = null;
        
        /// <summary>
        /// статический экземпляр класса логгера
        /// </summary>
        private static MessageLogger _Instance = new MessageLogger();

        /// <summary>
        /// Инициализация MessageLogger
        /// </summary>
        /// <param name="sendLogMessageHandler">Задает внешний обработчик добавления в лог сообщения</param>
        public static void InitializeLogger(Action<string> sendLogMessageHandler)
        {
            _Instance._OnSendLogMessageReised = sendLogMessageHandler;
        }

        /// <summary>
        /// Отправка ообщения логгеру
        /// </summary>
        /// <param name="message">Текст сообщения</param>
        public static void LogMessage(string message)
        {
            if (_Instance._OnSendLogMessageReised != null)
            {
                _Instance._OnSendLogMessageReised(message);
            }
        }
    }
}
